import java.util.*;
import java.awt.*;
import java.applet.*;
import java.text.*;

/**
 * A Clock Applet - no excuse - watch the time!  ;-)  
 * Add code to make it go around. 
*/

public class Clock extends Applet  {      
    private int lastxs, lastys, lastxm,
                lastym, lastxh, lastyh;   
    private SimpleDateFormat formatter;     // Formats the date displayed
    private Date currentDate;               // Used to get date to display
    private Color handColor;                // Color of main hands and dial
    private Color numberColor;              // Color of second hand and numbers
    private int xcenter = 80, ycenter = 55; // Center position

    public void init() {
        lastxs = lastys = lastxm = lastym = lastxh = lastyh = 0;
        formatter = new SimpleDateFormat ("EEE MMM dd hh:mm:ss yyyy", Locale.getDefault());
        handColor = Color.blue;
        numberColor = Color.darkGray;
        resize(300,300);            
    }

    public void paint(Graphics g) {

		// Draw the circle and numbers
		g.setColor(handColor);
		g.drawArc(xcenter-50, ycenter-50, 100, 100, 0, 360);
		g.setColor(numberColor);
		g.drawString("9", xcenter-45, ycenter+3); 
		g.drawString("3", xcenter+40, ycenter+3);
		g.drawString("12", xcenter-5, ycenter-37);
		g.drawString("6", xcenter-3, ycenter+45);

		int xh, yh, xm, ym, xs, ys;
		int s = 0, m = 10, h = 10;
		currentDate = new Date();

		formatter.applyPattern("s");
		try { s = Integer.parseInt(formatter.format(currentDate));} 
		catch (NumberFormatException n) {	s = 0;	}
		formatter.applyPattern("m");	
		try { m = Integer.parseInt(formatter.format(currentDate));} 
		catch (NumberFormatException n) {	m = 10;	}    
		formatter.applyPattern("h");
		try { h = Integer.parseInt(formatter.format(currentDate));} 
		catch (NumberFormatException n) {	h = 10;	}
    
		// Set position of the ends of the hands
		xs = (int) (Math.cos(s * Math.PI / 30 - Math.PI / 2) * 45 + xcenter);
		ys = (int) (Math.sin(s * Math.PI / 30 - Math.PI / 2) * 45 + ycenter);
		xm = (int) (Math.cos(m * Math.PI / 30 - Math.PI / 2) * 40 + xcenter);
		ym = (int) (Math.sin(m * Math.PI / 30 - Math.PI / 2) * 40 + ycenter);
		xh = (int) (Math.cos((h*30 + m / 2) * Math.PI / 180 - Math.PI / 2) * 30 + xcenter);
		yh = (int) (Math.sin((h*30 + m / 2) * Math.PI / 180 - Math.PI / 2) * 30 + ycenter);

		// Erase if necessary
		g.setColor(getBackground());
		if (xs != lastxs || ys != lastys) 
		{
			g.drawLine(xcenter, ycenter, lastxs, lastys);
		}
		if (xm != lastxm || ym != lastym) 
		{
			g.drawLine(xcenter, ycenter-1, lastxm, lastym);
			g.drawLine(xcenter-1, ycenter, lastxm, lastym); 
		}
		if (xh != lastxh || yh != lastyh) 
		{
			g.drawLine(xcenter, ycenter-1, lastxh, lastyh);
			g.drawLine(xcenter-1, ycenter, lastxh, lastyh); 
		}
		g.setColor(numberColor);
		g.drawLine(xcenter, ycenter, xs, ys);
		g.setColor(handColor);
		g.drawLine(xcenter, ycenter-1, xm, ym);
		g.drawLine(xcenter-1, ycenter, xm, ym);
		g.drawLine(xcenter, ycenter-1, xh, yh);
		g.drawLine(xcenter-1, ycenter, xh, yh);
		lastxs = xs; lastys = ys;
		lastxm = xm; lastym = ym;
		lastxh = xh; lastyh = yh;
    }
}